package pack.c0d3.com.hudhelloworldapp;

import android.content.Context;
import android.graphics.Color;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.os.Bundle;
import android.support.design.widget.FloatingActionButton;
import android.support.design.widget.Snackbar;
import android.support.v7.app.AppCompatActivity;
import android.support.v7.widget.Toolbar;
import android.view.View;
import android.view.Menu;
import android.view.MenuItem;
import android.app.Activity;
import android.app.ProgressDialog;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.os.AsyncTask;
import android.os.Bundle;
import android.util.Log;
import android.webkit.WebView;
import android.webkit.WebViewClient;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageView;
import android.widget.TextView;
import android.widget.Toast;
import android.os.Handler;
//import android.widget.ImageView;
 // Library for head orientation sensor and http connectivity
import com.reconinstruments.os.HUDOS;
 // Libraries 2, and 3 is for head orientation sensor
import com.reconinstruments.os.hardware.sensors.HUDHeadingManager; // 2
import com.reconinstruments.os.hardware.sensors.HeadLocationListener; // 3

 // Http connectivtiy Libraries ...
import com.reconinstruments.os.connectivity.HUDConnectivityManager;
import com.reconinstruments.os.connectivity.http.HUDHttpRequest;
import com.reconinstruments.os.connectivity.http.HUDHttpResponse;


public class MainActivity extends Activity implements HeadLocationListener {

    // Text view to show values on screen
    public TextView txtPitch;
    public TextView txtYaw;
    public TextView txtRoll;
    public TextView txtXDegree;
    public TextView txtYDegree;
    // Text input box for entering the remote side IP
    public EditText txtIP;
    // Text input box for entering the remote side Port
    public EditText txtPort;
    // Connect button
    public Button btnConnect;
    // Fire Button
    public Button btnFire;
    // Burst Fire Mode
    public Button btnBurst;

    // HUD (Heads Up Display) orientation sensor manager that will turn on the orientation sensor and initialize it for using it.
    private HUDHeadingManager orientation_sensor_manager;
    // HUD (Heads Up Display) connectivity manager that will make the HUD as a wifi hotspot to be connected to, not needed if we are connected over wifi router.
    //private HUDConnectivityManager connectivity_manager;d
    // Webview to show the stream
    private WebView browser_view = null;
    //private int mDialogRefCnt = 0;
    private ProgressDialog mDialog;
    public char commandToSend;
    public char commandToSend2;
    public char prev_CommandSent;
    public char prev_CommandSent2;
    private TCPClient client; // Tcp client engine
    private Thread[] threads = new Thread[1000]; // Setup new threads up to 1000 threads only.
    private int threadsCounter = 0; // Set the thread counter to 0.
    private String vulcanIP = "192.168.19.133"; // Set the IP address of the remote side to connect to, by default it is 192.168.19.133.
    private int vulcanPort; // Set the port of the remote side to connect to, by default it is 1994.
   // private Handler handler;


    //Tilt array
    char[] tiltArray    = {'a', 'b', 'c', 'd', 'e', 'f', 'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n', 'o',
            'p', 'q', 'r', 's', 't', 'u', 'v', 'w', 'x', 'y', 'z'};

    //Pan array
    char[] panArray = {'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'I', 'J', 'K', 'L', 'M', 'N', 'O',
            'P', 'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X', 'Y', 'Z'};


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        txtPitch = (TextView) findViewById(R.id.txtPitch);
        txtYaw = (TextView) findViewById(R.id.txtYaw);
        txtRoll = (TextView) findViewById(R.id.txtRoll);
        txtXDegree = (TextView) findViewById(R.id.txtXDeg);
        txtYDegree = (TextView) findViewById(R.id.txtYDeg);
        txtIP = (EditText) findViewById(R.id.txtIP);
        txtPort = (EditText) findViewById(R.id.txtPort);
        btnConnect = (Button) findViewById(R.id.btnConnect);
        btnFire  = (Button) findViewById(R.id.btnFire);
        btnBurst = (Button) findViewById(R.id.btnBurst);

         if(orientation_sensor_manager == null) // Check if orientation sensor manager is null
            orientation_sensor_manager = (HUDHeadingManager) HUDOS.getHUDService(HUDOS.HUD_HEADING_SERVICE); // Start the orientation service to be used.


        btnConnect.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {

                //Get the IP input by the user
                vulcanIP = txtIP.getText().toString(); // Get the IP that user set.
                // Get the port input by the user
                vulcanPort = Integer.valueOf(txtPort.getText().toString()); // Get the port that user set.

                // are we connected?
                if (!client.isConnected) {
                    // make a new thread for connecting.
                    threads[threadsCounter] = new Thread(new ClientThread());
                    // start thread we created.
                    threads[threadsCounter].start();
                    // increase counter.
                    threadsCounter++;
                } else {
                    btnConnect.setBackgroundColor(Color.green(254)); // Check button background color to green which indicates the HUD is connected to remote side.

                }

            }
        });


       btnFire.setOnClickListener(new View.OnClickListener() {
           @Override
           public void onClick(View v) {
               commandToSend = '0';
               new MyTask().execute();
           }
       });


        btnBurst.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View v) {
                commandToSend = '9';
                new MyTask().execute();
            }
        });



/*
        ImageView target_cursor = (ImageView) findViewById(R.id.imageView);
        target_cursor.setAlpha(127);
*/

        // Get HUD connectivity service running
        //connectivity_manager = (HUDConnectivityManager) HUDOS.getHUDService(HUDOS.HUD_CONNECTIVITY_SERVICE);




    }


    /* Abstract Class (HeadLocationListener) Methods  starts from here */


    /**
     * Listener that listens for new head movements.
     * @param v Rotation through Y (Pitch)
     * @param v1 Rotation through X (Yaw)
     * @param v2 Rotation through Z (Roll)
     */
    @Override
    public void onHeadLocation(float v, float v1, float v2) {

        //handler = new Handler();
      //  HeadMovementRunnable headMovement = new HeadMovementRunnable(v, v1, v2);
       // handler.post(headMovement);

        String yaw = ""; // X
        String pitch = ""; // Y
        String roll = ""; // Z


        try {

              // check if the goggles rotation to Y degrees is between 275 and 350 degrees.
            if (v >= 275 && v <= 350) {
                //     if(v >= -180 && v <= 180) {
           //     if (v != prevXDeg) {
                    yaw = String.valueOf(v);
                    Degree xzYaw_Degree = new Degree(); // Create a new instance of Degree
                    float yawDegree = xzYaw_Degree.map(v, 275, 350, 52, 152); // Map the goggles degrees to the gun degrees.
                    txtXDegree.setText(String.valueOf(yawDegree));
                    if (client.isConnected) { // Are we connected?
                        try {
                            // Map degree to an index  within tilt array range
                            int pan_index = (Math.round(yawDegree) - 52) / 4; // (Current_xzYawDegreeInGun - minYawDegreeInGun) / ServoInGunDegreeSteps
                            commandToSend = panArray[pan_index]; // set the command to send which is in our case the letter that is mapped to certain degree.
                            new MyTask().execute(); // execute the send method.

                        } catch (Exception ex) {
                        }
                    }
             //   }
               // prevXDeg = x;

            }

            // check if the goggles rotation to X degrees is between -44 and 36 degrees.
            if (v1 >= -44 && v1 <= 36) {
                //     }
                //if(v >= -45 && v <= 45) {
                //if (v1 != prevYDeg) {
                    pitch = String.valueOf(v1);
                    Degree yzPitch_Degree = new Degree();
                    float pitchDegree = yzPitch_Degree.map(v1, 36, -44, 65, 115); // Map the goggles degrees to the gun degrees.
                    txtYDegree.setText(String.valueOf(pitchDegree));
                    if (client.isConnected) { // Are we connected?
                        try {
                            // Map degree to an index  within pan array range
                            int tilt_index = (Math.round(pitchDegree) - 65) / 2; // (Current_yzPitchDegreeInGun - minPitchDegreeInGun) / ServoInGunDegreeSteps

                            commandToSend2 = tiltArray[tilt_index]; // set the command to send which is in our case the letter that is mapped to certain degree.
                            new MyTask().execute(); // execute the send method.

                        } catch (Exception ex) {
                            // Do nothing ...
                        }
                    }
         //       }
               // prevYDeg = y;
            }
            // }
            roll = String.valueOf(v2);


            //float pitchDegree = yzPitch_Degree.getDegree();
            txtYaw.setText(yaw);
            txtPitch.setText(pitch);
            txtRoll.setText(roll);

        } catch (Exception exx) {

            // First try ... // Do Nothing ...
        }



    }


    /*

    public class HeadMovementRunnable implements Runnable {
        private float x;
        private float y;
        private float z;
        private float prevXDeg = 0;
        private float prevYDeg = 0;

        public HeadMovementRunnable (float X, float Y, float Z) {
            this.x = X;
            this.y = Y;
            this.z = Z;
        }

        public void run() {


            String yaw = ""; // X
            String pitch = ""; // Y
            String roll = ""; // Z


            try {
                if (x >= 40 && x <= 309) {
                    //     if(v >= -180 && v <= 180) {
                    if (x != prevXDeg) {
                            yaw = String.valueOf(x);
                            Degree xzYaw_Degree = new Degree();
                            xzYaw_Degree.Degree(0f, x, z);
                            float yawDegree = xzYaw_Degree.map(x, 230, 360, 52, 152);
                            //txtXDegree.setText(String.valueOf(yawDegree));
                            if (client.isConnected) {
                                try {
                                    // Map degree to an index  within tilt array range
                                    int pan_index = (Math.round(yawDegree) - 52) / 4; // (Current_xzYawDegreeInGun - minYawDegreeInGun) / ServoInGunDegreeSteps
                                    commandToSend = panArray[pan_index];
                                    new MyTask().execute();

                                } catch (Exception ex) {
                                }
                            }
                        }
                        prevXDeg = x;

                }

                if (y >= -44 && y <= 36) {
                    //     }
                    //if(v >= -45 && v <= 45) {
                    if (y != prevYDeg) {
                        pitch = String.valueOf(y);
                        Degree yzPitch_Degree = new Degree();
                        yzPitch_Degree.Degree(0f, y, z);
                        //float yawDegree = xzYaw_Degree.getDegree();
                        //yzPitch_Degree.map(45);
                        float pitchDegree = yzPitch_Degree.map(y, 36, -44, 65, 115);
                  //      txtYDegree.setText(String.valueOf(pitchDegree));
                        if (client.isConnected) {
                            try {
                                // Map degree to an index  within pan array range
                                int tilt_index = (Math.round(pitchDegree) - 65) / 2; // (Current_yzPitchDegreeInGun - minPitchDegreeInGun) / ServoInGunDegreeSteps

                                commandToSend2 = tiltArray[tilt_index];
                                new MyTask().execute();

                            } catch (Exception ex) {
                                // Do nothing ...

                            }
                        }
                    }
                    prevYDeg = y;
                }
                // }
                roll = String.valueOf(z);


                //float pitchDegree = yzPitch_Degree.getDegree();
            //    txtYaw.setText(yaw);
            //    txtPitch.setText(pitch);
            //    txtRoll.setText(roll);

            } catch (Exception exx) {

                // First try ... // Do Nothing ...
            }
        }

        }

*/



        /* Abstract Class (HeadLocationListener) Methods end here */



    class MyTask extends AsyncTask<Void, Void, Void> {

        @Override
        protected Void doInBackground(Void... params) {

            try {


                        // set the user command and send it to server side.
               if(commandToSend != prev_CommandSent) {
                   if(commandToSend != 0x0)
                   client.send(commandToSend);
               }

               if(commandToSend2 != prev_CommandSent2) {
                   if(commandToSend2 != 0x0)
                   client.send(commandToSend2);
               }


                prev_CommandSent = commandToSend;
                prev_CommandSent2 = commandToSend2;

            } catch (Exception e) {
                //e.printStackTrace();
            }


        /*    if(received != null) {
                txtReplay.append(received);
            } */

            return null;
        }

    }


    /**
     * Runnable thread (Multi Thread) that will run for us to initiate the connection, if there is no connection thread will crash but the app will not.
     */
    class ClientThread implements Runnable {

        boolean isWorking = true;

        @Override
        public void run() {

            // Get the connectivity service that will allow us use the tcp protocol in the phone to send our packets.
            ConnectivityManager connectivityManager = (ConnectivityManager) getApplicationContext().getSystemService(Context.CONNECTIVITY_SERVICE);
            // Get network info, last status of device connectivity.
            NetworkInfo networkInfo = connectivityManager.getActiveNetworkInfo();

            if (networkInfo != null && networkInfo.isConnected() && networkInfo.isAvailable()) // If device is connected to a network then do the following ...
            {
                // Set a new instance of TCPClient class.
                client = new TCPClient(vulcanIP, vulcanPort); // start a new tcp client
                // Initiate connection session.
                client.initiateConnection(); // initiate tcp connection
            } else {
                final int SHORT_DELAY = 2000; // 2 seconds //  give a delay of 2 seconds (2000 ms)
                // PROMPT USER THAT NETWORK IS DISCONNECT
                Toast.makeText(MainActivity.this, "There is no active network connection!", Toast.LENGTH_SHORT).show(); // Show a toast message for the user ...

            }

        }

    }




    @Override
    public void onStart() {
        Log.i("RECON DEBUG: ", "Activity Started .... ");
        super.onStart();
        orientation_sensor_manager.register(this);

    }

    @Override
    protected void onStop() {
        Log.i("RECON DEBUG: ", "Activity Stopped. ");
        super.onStop();
        orientation_sensor_manager.unregister(this);

    }


    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_main, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
