package pack.c0d3.com.hudhelloworldapp;

/**
 * Created by Fresh on 1/20/2016.
 */

import android.util.Log;

import java.io.BufferedWriter;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.InetSocketAddress;
import java.net.Socket;
import java.net.SocketAddress;
import java.net.UnknownHostException;


/**
 * Coded by Rezk Bouras on 17/05/2016.
 */

public class TCPClient {

    private static String IP = "";
    private static int PORT = 0;
    //private MulticastSocket connectivity_socket;
    private Socket connectivity_socket;
    private boolean stayWithOpenConnection = false;
    public static boolean isConnected = false;
    private PrintWriter out = null;

    public TCPClient(String IP, int port) {

        // Set the IP Address
        this.setIP(IP);
        // Set the Port
        this.setPORT(port);
    }

    public boolean initiateConnection() {

        try {
            // SocketAddress socket_addr;
            SocketAddress socket_addr = new InetSocketAddress(IP, PORT);
            connectivity_socket = new Socket();
            // Set keep alive feature.
            connectivity_socket.setKeepAlive(stayWithOpenConnection);
            connectivity_socket.connect(socket_addr, 3000); // Connect to the end point (rover) and wait 3 seconds as timeout until we get connected, if we are connected we should continue, otherwise we get out of try block.
            isConnected = true; // set the connected status to true.


        } catch (UnknownHostException e) {
                System.err.println("Don't know about host " + IP);
            System.exit(1);
        } catch (IOException e) {
              System.err.println("Couldn't get connection I/O for " + IP);
            e.getMessage();
            System.exit(1);
        }

        return connectivity_socket.isConnected();
    }


    public void send(char command) {
        //String received = "";

        if (connectivity_socket.isConnected()) {

            try {
                out = new PrintWriter(new BufferedWriter(new OutputStreamWriter(connectivity_socket.getOutputStream())),true); // store our data that we want to send n memory stream type, and tunnel it through the socket that is connected to the end point.
                out.println(command); // confirm sending data to the endpoint.
                Thread.sleep(100);
            } catch (Exception ex) {
                Log.d("TAG", ex.getMessage());
            }

           /* if (received != "") {

                // show received data on screen.

            }*/

            //return received;
        }

    }


    public static String getIP() {
        return IP;
    }

    public static void setIP(String IP) {
        TCPClient.IP = IP;
    }

    public static int getPORT() {
        return PORT;
    }

    public static void setPORT(int PORT) {
        TCPClient.PORT = PORT;
    }
}
